config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

# Keep same perms on rc.jboss-as.new:
preserve_perms  etc/rc.d/rc.jboss-as.new

config etc/jboss-as/standalone/configuration/standalone-ha.xml.new
config etc/jboss-as/standalone/configuration/standalone.xml.new
config etc/jboss-as/standalone/configuration/standalone-preview.xml.new
config etc/jboss-as/standalone/configuration/standalone-preview-ha.xml.new
config etc/jboss-as/standalone/configuration/logging.properties.new
config etc/jboss-as/standalone/configuration/standalone-xts.xml.new
config etc/jboss-as/standalone/configuration/mgmt-users.properties.new
config etc/jboss-as/standalone/standalone.conf.new
config etc/jboss-as/domain/domain.conf.new
config etc/jboss-as/domain/configuration/logging.properties.new
config etc/jboss-as/domain/configuration/domain-preview.xml.new
config etc/jboss-as/domain/configuration/host.xml.new
config etc/jboss-as/domain/configuration/mgmt-users.properties.new
config etc/jboss-as/domain/configuration/domain.xml.new
( cd usr/bin ; rm -rf jboss-admin.sh )
( cd usr/bin ; ln -sf ../share/jboss-as/bin/jboss-admin.sh jboss-admin.sh )
( cd usr/bin ; rm -rf domain.sh )
( cd usr/bin ; ln -sf ../share/jboss-as/bin/domain.sh domain.sh )
( cd usr/bin ; rm -rf wsconsume.sh )
( cd usr/bin ; ln -sf ../share/jboss-as/bin/wsconsume.sh wsconsume.sh )
( cd usr/bin ; rm -rf wsprovide.sh )
( cd usr/bin ; ln -sf ../share/jboss-as/bin/wsprovide.sh wsprovide.sh )
( cd usr/bin ; rm -rf standalone.sh )
( cd usr/bin ; ln -sf ../share/jboss-as/bin/standalone.sh standalone.sh )
( cd usr/share/jboss-as/bin ; rm -rf domain.conf )
( cd usr/share/jboss-as/bin ; ln -sf ../../../../etc/jboss-as/domain/domain.conf domain.conf )
( cd usr/share/jboss-as/bin ; rm -rf standalone.conf )
( cd usr/share/jboss-as/bin ; ln -sf ../../../../etc/jboss-as/standalone/standalone.conf standalone.conf )
( cd usr/share/jboss-as ; rm -rf standalone )
( cd usr/share/jboss-as ; ln -sf ../../../var/lib/jboss-as/standalone standalone )
( cd usr/share/jboss-as ; rm -rf domain )
( cd usr/share/jboss-as ; ln -sf ../../../var/lib/jboss-as/domain domain )
( cd var/lib/jboss-as/standalone ; rm -rf tmp )
( cd var/lib/jboss-as/standalone ; ln -sf ../../../tmp/jboss-as/standalone tmp )
( cd var/lib/jboss-as/standalone ; rm -rf log )
( cd var/lib/jboss-as/standalone ; ln -sf ../../../log/jboss-as/standalone log )
( cd var/lib/jboss-as/standalone ; rm -rf configuration )
( cd var/lib/jboss-as/standalone ; ln -sf ../../../../etc/jboss-as/standalone/configuration configuration )
( cd var/lib/jboss-as/domain ; rm -rf configuration )
( cd var/lib/jboss-as/domain ; ln -sf ../../../../etc/jboss-as/domain/configuration configuration )
( cd etc/jboss-as/standalone/configuration ; rm -rf standalone_xml_history )
( cd etc/jboss-as/standalone/configuration ; ln -sf ../../../../var/lib/jboss-as/standalone/standalone_xml_history standalone_xml_history )
( cd etc/jboss-as/domain/configuration ; rm -rf host_xml_history )
( cd etc/jboss-as/domain/configuration ; ln -sf ../../../../var/lib/jboss-as/domain/host_xml_history host_xml_history )
( cd etc/jboss-as/domain/configuration ; rm -rf domain_xml_history )
( cd etc/jboss-as/domain/configuration ; ln -sf ../../../../var/lib/jboss-as/domain/domain_xml_history domain_xml_history )
